package main

import "encoding/json"
import "github.com/joeshaw/iso8601"

type SteemVirtualTransaction struct {
	TxID      string            `json:"trx_id"`
	BlockNum  uint64            `json:"block"`
	TxInBlock uint64            `json:"trx_in_block"`
	OpInTx    int               `json:"op_in_trx"`
	IsVirtual int               `json:"virtual_op"`
	Timestamp iso8601.Time      `json:"timestamp"`
	Op        []json.RawMessage `json:"op"`
}

func (rpc *JSONRPC) GetVirtualOpsInBlock(blockNum int) ([]*SteemVirtualTransaction, error) {
	raw, err1 := rpc.Call("condenser_api.get_ops_in_block", blockNum, true)
	if err1 != nil {
		return nil, err1
	}

	tmp := make([]SteemVirtualTransaction)
	//var result []interface{}
	err2 := json.Unmarshal(raw, &tmp)
	if err2 != nil {
		return result, nil
	}
	return nil, err2
}

func (rpc *JSONRPC) GetOpsInBlock(blockNum int) (json.RawMessage, error) {
	r, err := rpc.Call("condenser_api.get_ops_in_block", blockNum, false)
	return r, err
}
